package com.huimv.admin.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.entity.ProdAnalysis;
import com.huimv.admin.entity.ProdSale;
import com.huimv.admin.entity.vo.ProdAnalysisVo;
import com.huimv.admin.service.IProdAnalysisService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 重要指标 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-22
 */
@RestController
@RequestMapping("/prod-analysis")
@CrossOrigin
public class ProdAnalysisController {

    @Autowired
    private IProdAnalysisService prodAnalysisService;

    @RequestMapping("/list")
    public Result list(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return prodAnalysisService.list(httpServletRequest,paramsMap);
    }

    @RequestMapping("/edit")
    public Result edit(HttpServletRequest httpServletRequest, @RequestBody ProdAnalysis prodAnalysis) {
        return prodAnalysisService.edit(httpServletRequest,prodAnalysis);
    }

    @RequestMapping("/add")
    public Result add(HttpServletRequest httpServletRequest, @RequestBody ProdAnalysisVo prodAnalysis) {
        String farmId = prodAnalysis.getFarmId();
        ProdAnalysis feed = prodAnalysis.getFeed();
        feed.setCreatTime(new Date());
        feed.setFarmId(Integer.valueOf(farmId));
        ProdAnalysis drug = prodAnalysis.getDrug();
        drug.setFarmId(Integer.valueOf(farmId));
        drug.setCreatTime(new Date());
        ProdAnalysis share = prodAnalysis.getShare();
        share.setFarmId(Integer.valueOf(farmId));
        share.setCreatTime(new Date());
        List<ProdAnalysis> prodAnalyses = new ArrayList<>();
        prodAnalyses.add(feed);
        prodAnalyses.add(drug);
        prodAnalyses.add(share);
        prodAnalysisService.remove(new QueryWrapper<ProdAnalysis>().eq("display_type",1).eq("farm_id",farmId));
        prodAnalysisService.saveBatch(prodAnalyses);
        return Result.SUCCESS();
    }
}
